; ##############################################################################
; ##############################################################################
; ##############################################################################
; alle SLAVES zum Messen auffordern, Achtung Spannung am SENSOR bricht ein		
; bei zuvielen Sensoren und ungnstigen Kabelverhltnissen						
DS_MESSEN_ALLE:
	;Reset und Presence-Test					
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX xCC (skip ROM)					
	ldi	temp1,0xCC			
	rcall ONE_WIRE_DATA_WRITE	
	; MASTER TX x44 (convert T)					
	ldi	temp1,0x44
	rcall ONE_WIRE_DATA_WRITE	
	; voll POWER (strong pullup )				
	sbi (ONE_WIRE_PORT),(ONE_WIRE_PORTBIT)	; HIGH-PEGEL 	
	sbi (ONE_WIRE_DDR), (ONE_WIRE_PORTBIT)	; AUF AUSGANG	
	; Pause 									
	rcall WAIT_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ROM auslesen																	
; nur ein SLAVE vorhanden !														
;																				
; x33 senden und 8 BYTES empfangen und im SRAM ablegen							
DS_ROM_READ_1_SLAVE:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX x33 (read ROM)					
	ldi	temp1,0x33			
	rcall ONE_WIRE_DATA_WRITE
	; MASTER RX 8 BYTE und im SRAM ablegen		
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+0),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+1),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+2),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+3),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+4),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+5),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+6),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+7),temp1

	; CRC- CHECK					
	rcall ONE_WIRE_ROM_CRC7			; OUT: C
	brcc DS_ROM_READ_1_SLAVE_ERROR
	ret
DS_ROM_READ_1_SLAVE_ERROR:

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; Einen bekannten SLAVE ansprechen und auslesen.								
; Mehrere SLAVES knnen vorhanden sein !										
; (der 8 BYTE ROM-CODE muss auf die jeweiligen SLAVES angepasst werden)			
;																				
DS_SCRATCHPAD_READ_DIREKT_SLAVE_00:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX x55 (MATCH ROM)					
	ldi	temp1,0x55
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX 8 BYTE ROM CODE					
	ldi ZL,  low(SENSOR_ROM_00*2); Z auf Tabelle
	ldi ZH, high(SENSOR_ROM_00*2)
	; 8 Byte (ROM) aus Tabelle laden und senden		
	rcall DS_SCRATCHPAD_temp1_Z
	; SCRATCHPAD auslesen und Temperaturen berechnen
	rcall DS_SCRATCHPAD_READ
	; TEMPERATURWERTE ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR9_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR9_H)
	STS(adr_TEMPERATUR9_0_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR9_0_H),temp2
	; TEMPERATURWERTE  ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR_H)
	STS(adr_TEMPERATUR_0_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR_0_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; Einen bekannten SLAVE ansprechen und auslesen.								
; Mehrere SLAVES knnen vorhanden sein !										
; (der 8 BYTE ROM-CODE muss auf die jeweiligen SLAVES angepasst werden)			
;																				
DS_SCRATCHPAD_READ_DIREKT_SLAVE_01:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX x55 (MATCH ROM)					
	ldi	temp1,0x55
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX 8 BYTE ROM CODE					
	ldi ZL,  low(SENSOR_ROM_01*2); Z auf Tabelle
	ldi ZH, high(SENSOR_ROM_01*2)
	; 8 Byte (ROM) aus Tabelle laden und senden		
	rcall DS_SCRATCHPAD_temp1_Z
	; SCRATCHPAD auslesen und Temperaturen berechnen
	rcall DS_SCRATCHPAD_READ
	; TEMPERATURWERTE ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR9_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR9_H)
	STS(adr_TEMPERATUR9_1_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR9_1_H),temp2
	; TEMPERATURWERTE  ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR_H)
	STS(adr_TEMPERATUR_1_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR_1_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; Einen bekannten SLAVE ansprechen und auslesen.								
; Mehrere SLAVES knnen vorhanden sein !										
; (der 8 BYTE ROM-CODE muss auf die jeweiligen SLAVES angepasst werden)			
;																				
DS_SCRATCHPAD_READ_DIREKT_SLAVE_02:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX x55 (MATCH ROM)					
	ldi	temp1,0x55
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX 8 BYTE ROM CODE					
	ldi ZL,  low(SENSOR_ROM_02*2); Z auf Tabelle
	ldi ZH, high(SENSOR_ROM_02*2)
	; 8 Byte (ROM) aus Tabelle laden und senden		
	rcall DS_SCRATCHPAD_temp1_Z
	; SCRATCHPAD auslesen und Temperaturen berechnen
	rcall DS_SCRATCHPAD_READ
	; TEMPERATURWERTE ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR9_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR9_H)
	STS(adr_TEMPERATUR9_2_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR9_2_H),temp2
	; TEMPERATURWERTE  ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR_H)
	STS(adr_TEMPERATUR_2_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR_2_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; Einen bekannten SLAVE ansprechen und auslesen.								
; Mehrere SLAVES knnen vorhanden sein !										
; (der 8 BYTE ROM-CODE muss auf die jeweiligen SLAVES angepasst werden)			
;																				
DS_SCRATCHPAD_READ_DIREKT_SLAVE_03:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX x55 (MATCH ROM)					
	ldi	temp1,0x55
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX 8 BYTE ROM CODE					
	ldi ZL,  low(SENSOR_ROM_03*2); Z auf Tabelle
	ldi ZH, high(SENSOR_ROM_03*2)
	; 8 Byte (ROM) aus Tabelle laden und senden		
	rcall DS_SCRATCHPAD_temp1_Z
	; SCRATCHPAD auslesen und Temperaturen berechnen
	rcall DS_SCRATCHPAD_READ
	; TEMPERATURWERTE ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR9_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR9_H)
	STS(adr_TEMPERATUR9_3_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR9_3_H),temp2
	; TEMPERATURWERTE  ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR_H)
	STS(adr_TEMPERATUR_3_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR_3_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; Einen bekannten SLAVE ansprechen und auslesen.								
; Mehrere SLAVES knnen vorhanden sein !										
; (der 8 BYTE ROM-CODE muss auf die jeweiligen SLAVES angepasst werden)			
;																				
DS_SCRATCHPAD_READ_DIREKT_SLAVE_04:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX x55 (MATCH ROM)					
	ldi	temp1,0x55
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX 8 BYTE ROM CODE					
	ldi ZL,  low(SENSOR_ROM_04*2); Z auf Tabelle
	ldi ZH, high(SENSOR_ROM_04*2)
	; 8 Byte (ROM) aus Tabelle laden und senden		
	rcall DS_SCRATCHPAD_temp1_Z
	; SCRATCHPAD auslesen und Temperaturen berechnen
	rcall DS_SCRATCHPAD_READ
	; TEMPERATURWERTE ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR9_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR9_H)
	STS(adr_TEMPERATUR9_4_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR9_4_H),temp2
	; TEMPERATURWERTE  ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR_H)
	STS(adr_TEMPERATUR_4_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR_4_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; Einen bekannten SLAVE ansprechen und auslesen.								
; Mehrere SLAVES knnen vorhanden sein !										
; (der 8 BYTE ROM-CODE muss auf die jeweiligen SLAVES angepasst werden)			
;																				
DS_SCRATCHPAD_READ_DIREKT_SLAVE_05:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX x55 (MATCH ROM)					
	ldi	temp1,0x55
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX 8 BYTE ROM CODE					
	ldi ZL,  low(SENSOR_ROM_05*2); Z auf Tabelle
	ldi ZH, high(SENSOR_ROM_05*2)
	; 8 Byte (ROM) aus Tabelle laden und senden		
	rcall DS_SCRATCHPAD_temp1_Z
	; SCRATCHPAD auslesen und Temperaturen berechnen
	rcall DS_SCRATCHPAD_READ
	; TEMPERATURWERTE ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR9_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR9_H)
	STS(adr_TEMPERATUR9_5_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR9_5_H),temp2
	; TEMPERATURWERTE  ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR_H)
	STS(adr_TEMPERATUR_5_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR_5_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; Einen bekannten SLAVE ansprechen und auslesen.								
; Mehrere SLAVES knnen vorhanden sein !										
; (der 8 BYTE ROM-CODE muss auf die jeweiligen SLAVES angepasst werden)			
;																				
DS_SCRATCHPAD_READ_DIREKT_SLAVE_06:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX x55 (MATCH ROM)					
	ldi	temp1,0x55
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX 8 BYTE ROM CODE					
	ldi ZL,  low(SENSOR_ROM_06*2); Z auf Tabelle
	ldi ZH, high(SENSOR_ROM_06*2)
	; 8 Byte (ROM) aus Tabelle laden und senden		
	rcall DS_SCRATCHPAD_temp1_Z
	; SCRATCHPAD auslesen und Temperaturen berechnen
	rcall DS_SCRATCHPAD_READ
	; TEMPERATURWERTE ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR9_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR9_H)
	STS(adr_TEMPERATUR9_6_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR9_6_H),temp2
	; TEMPERATURWERTE  ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR_H)
	STS(adr_TEMPERATUR_6_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR_6_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; Einen bekannten SLAVE ansprechen und auslesen.								
; Mehrere SLAVES knnen vorhanden sein !										
; (der 8 BYTE ROM-CODE muss auf die jeweiligen SLAVES angepasst werden)			
;																				
DS_SCRATCHPAD_READ_DIREKT_SLAVE_07:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX x55 (MATCH ROM)					
	ldi	temp1,0x55
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX 8 BYTE ROM CODE					
	ldi ZL,  low(SENSOR_ROM_07*2); Z auf Tabelle
	ldi ZH, high(SENSOR_ROM_07*2)
	; 8 Byte (ROM) aus Tabelle laden und senden		
	rcall DS_SCRATCHPAD_temp1_Z
	; SCRATCHPAD auslesen und Temperaturen berechnen
	rcall DS_SCRATCHPAD_READ
	; TEMPERATURWERTE ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR9_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR9_H)
	STS(adr_TEMPERATUR9_7_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR9_7_H),temp2
	; TEMPERATURWERTE  ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR_H)
	STS(adr_TEMPERATUR_7_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR_7_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; Einen bekannten SLAVE ansprechen und auslesen.								
; Mehrere SLAVES knnen vorhanden sein !										
; (der 8 BYTE ROM-CODE muss auf die jeweiligen SLAVES angepasst werden)			
;																				
DS_SCRATCHPAD_READ_DIREKT_SLAVE_08:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX x55 (MATCH ROM)					
	ldi	temp1,0x55
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX 8 BYTE ROM CODE					
	ldi ZL,  low(SENSOR_ROM_08*2); Z auf Tabelle
	ldi ZH, high(SENSOR_ROM_08*2)
	; 8 Byte (ROM) aus Tabelle laden und senden		
	rcall DS_SCRATCHPAD_temp1_Z
	; SCRATCHPAD auslesen und Temperaturen berechnen
	rcall DS_SCRATCHPAD_READ
	; TEMPERATURWERTE ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR9_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR9_H)
	STS(adr_TEMPERATUR9_8_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR9_8_H),temp2
	; TEMPERATURWERTE  ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR_H)
	STS(adr_TEMPERATUR_8_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR_8_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; Einen bekannten SLAVE ansprechen und auslesen.								
; Mehrere SLAVES knnen vorhanden sein !										
; (der 8 BYTE ROM-CODE muss auf die jeweiligen SLAVES angepasst werden)			
;																				
DS_SCRATCHPAD_READ_DIREKT_SLAVE_09:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX x55 (MATCH ROM)					
	ldi	temp1,0x55
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX 8 BYTE ROM CODE					
	ldi ZL,  low(SENSOR_ROM_09*2); Z auf Tabelle
	ldi ZH, high(SENSOR_ROM_09*2)
	; 8 Byte (ROM) aus Tabelle laden und senden		
	rcall DS_SCRATCHPAD_temp1_Z
	; SCRATCHPAD auslesen und Temperaturen berechnen
	rcall DS_SCRATCHPAD_READ
	; TEMPERATURWERTE ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR9_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR9_H)
	STS(adr_TEMPERATUR9_9_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR9_9_H),temp2
	; TEMPERATURWERTE  ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR_H)
	STS(adr_TEMPERATUR_9_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR_9_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DS_SCRATCHPAD_temp1_Z:
	; 8 Byte aus Tabelle laden und senden		
	LPM temp1, Z+  				; FAMILY CODE	
	rcall ONE_WIRE_DATA_WRITE
	LPM temp1, Z+				; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LPM temp1, Z+				; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LPM temp1, Z+				; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LPM temp1, Z+				; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LPM temp1, Z+				; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LPM temp1, Z+				; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LPM temp1, Z+				; CRC			
	rcall ONE_WIRE_DATA_WRITE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; SCRATCHPAD auslesen															
; nur ein SLAVE vorhanden !														
;																				
; xBE senden und 9 BYTES empfangen und im SRAM ablegen							
DS_SCRATCHPAD_READ_1_SLAVE:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX xCC (SKIP ROM)					
	ldi	temp1,0xCC
	rcall ONE_WIRE_DATA_WRITE
	; SCRATCHPAD auslesen und Temperaturen berechnen
	rcall DS_SCRATCHPAD_READ
	; TEMPERATURWERTE ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR9_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR9_H)
	STS(adr_TEMPERATUR9_0_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR9_0_H),temp2
	; TEMPERATURWERTE  ZWISCHENERGEBNIS zuordnen		
	LDS temp1,(adr_TEMPERATUR_L)			; aus SRAM holen	
	LDS temp2,(adr_TEMPERATUR_H)
	STS(adr_TEMPERATUR_0_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR_0_H),temp2

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; SCRATCHPAD auslesen															
;																				
; SCRATCHPAD auslesen und CRC berechnen											
;																				
DS_SCRATCHPAD_READ:
	; MASTER TX xBE (read SCRATCHPAD)					
	ldi	temp1,0xBE			
	rcall ONE_WIRE_DATA_WRITE
	; MASTER RX 9 BYTE und im SRAM ablegen		
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_SCRATCHPAD_BEREICH+0),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_SCRATCHPAD_BEREICH+1),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_SCRATCHPAD_BEREICH+2),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_SCRATCHPAD_BEREICH+3),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_SCRATCHPAD_BEREICH+4),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_SCRATCHPAD_BEREICH+5),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_SCRATCHPAD_BEREICH+6),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_SCRATCHPAD_BEREICH+7),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_DS_SCRATCHPAD_BEREICH+8),temp1
	; CRC CHECK													
	rcall ONE_WIRE_SCRATCHPAD_CRC8	; OUT: (CRC)				
	brcc DS_SCRATCHPAD_READ_ERROR	; CARRY=0 ==> SPRUNG		
;-------------------------------------------------------------------------------
	; TEMPERATURBERECHNUNG (0,5 GRD)	
	LDS temp1,(adr_DS_SCRATCHPAD_BEREICH+0)	; aus SRAM laden	
	LDS temp2,(adr_DS_SCRATCHPAD_BEREICH+1)	
	rcall DS_TEMPERATUR_BERECHNEN_9BIT		; INP: temp1+2		
	; ZWISCHENERGEBNIS					
	STS(adr_TEMPERATUR9_L),temp1			; im SRAM ablegen	
	STS(adr_TEMPERATUR9_H),temp2
	; TEMPERATURBERECHNUNG (0,1 GRD) 	
	LDS temp1,(adr_DS_SCRATCHPAD_BEREICH+0)	
	LDS temp2,(adr_DS_SCRATCHPAD_BEREICH+1)	
	LDS temp6,(adr_DS_SCRATCHPAD_BEREICH+6)	
	rcall DS_TEMPERATUR_BERECHNEN			; INP: temp1+2+6
	; ZWISCHENERGEBNIS					
	STS(adr_TEMPERATUR_L),temp1				; im SRAM ablegen	
	STS(adr_TEMPERATUR_H),temp2
	ret
;-------------------------------------------------------------------------------
DS_SCRATCHPAD_READ_ERROR:
	; ZWISCHENERGEBNIS					
	STS(adr_TEMPERATUR9_L),NULL			; im SRAM ablegen	
	STS(adr_TEMPERATUR9_H),NULL
	; ZWISCHENERGEBNIS					
	STS(adr_TEMPERATUR_L),NULL			; im SRAM ablegen	
	STS(adr_TEMPERATUR_H),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; SCRATCHPAD beschreiben, vorsicht, alle Sensoren knnen hiermit gleichzeitig	
; beschrieben werden															
; x4E senden  (2 BYTES senden und im SCRATCHPAD ablegen)						
DS_SCRATCHPAD_WRITE_1_SLAVE:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX xCC (SKIP ROM)					
	ldi	temp1,0xCC
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX x4E (WRITE SCRATCHPAD)					
	ldi	temp1,0x4E			
	rcall ONE_WIRE_DATA_WRITE
	; DATENBYTE (high)
	ldi	temp1,0x22
	rcall ONE_WIRE_DATA_WRITE
	; DATENBYTE (LOW)
	ldi	temp1,0x11
	rcall ONE_WIRE_DATA_WRITE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; SCRATCHPAD ins EEPROM , vorsicht, alle Sensoren knnen hiermit gleichzeitig	
; beschrieben werden															
; x48 senden (COPPY SCRATCHPAD in EEPROM)										
DS_SCRATCHPAD_COPPY_1_SLAVE:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX xCC (SKIP ROM)					
	ldi	temp1,0xCC
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX x48 (COPPY SCRATCHPAD in EEPROM)
	ldi	temp1,0x48			
	rcall ONE_WIRE_DATA_WRITE
	; voll POWER (strong pullup )				
	sbi (ONE_WIRE_PORT),(ONE_WIRE_PORTBIT)	; HIGH-PEGEL 	
	sbi (ONE_WIRE_DDR), (ONE_WIRE_PORTBIT)	; AUF AUSGANG	
	; Pause 									
	rcall WAIT_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; EEPROM ins SCRATCHPAD , vorsicht, alle Sensoren knnen hiermit gleichzeitig	
; beschrieben werden															
; xB8 senden (COPPY EEPROM in SCRATCHPAD)										
DS_SCRATCHPAD_RECALLEEPROM_1_SLAVE:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX xCC (SKIP ROM)					
	ldi	temp1,0xCC
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX xB8 (COPPY EEPROM in SCRATCHPAD)
	ldi	temp1,0xB8			
	rcall ONE_WIRE_DATA_WRITE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Berechnung der Temperatur mit 0,5 GRD GENAUIGKEIT								
; inp: temp1+2																	
; OUT: temp1+2																	
DS_TEMPERATUR_BERECHNEN_9BIT:
	; TESTZAHLEN	
	;ldi temp1, 0xCE	; - 25
	;ldi temp2, 0xFF

	; negativ ?
	tst temp2
	brmi DS_TEMPERATUR_BERECHNEN_9BIT_NEGATV
	rjmp DS_TEMPERATUR_BERECHNEN_9BIT_POSITIV
;-------------------------------------------------------------------------------
DS_TEMPERATUR_BERECHNEN_9BIT_POSITIV:
	; BERECHNUNG	
	rcall DS_TEMPERATUR_BERECHNEN_9BIT_B
	ret
;-------------------------------------------------------------------------------
DS_TEMPERATUR_BERECHNEN_9BIT_NEGATV:
	; invertieren +1
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
	; BERECHNUNG	
	rcall DS_TEMPERATUR_BERECHNEN_9BIT_B
	; invertieren +1
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
	ret
;-------------------------------------------------------------------------------
DS_TEMPERATUR_BERECHNEN_9BIT_B:
	; mal 5 (4 mal addieren)			
	mov temp,temp1

	add temp1,temp	; x2
	adc temp2,NULL
	add temp1,temp	; x3
	adc temp2,NULL
	add temp1,temp	; x4
	adc temp2,NULL
	add temp1,temp	; x5
	adc temp2,NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Berechnung der Temperatur mit 0,1 GRD GENAUIGKEIT								
;																				
; TEMPERATUR= TEMP_READ - 0,25 + (COUNT_PER_C - COUNT_REMAIN)/COUNT_PER_C		
;																				
; TEMPERATUR= TEMP_READ - 0,25 + (16 - COUNT_REMAIN)/16							
;																				
; TEMPERATUR= TEMP_READ - 2 + (160 - 10*COUNT_REMAIN)/16						
;																				
; inp: temp1+2+6(COUNT_REMAIN)													
DS_TEMPERATUR_BERECHNEN:
	; TESTZAHLEN	
	;ldi temp1,0xCE	; -25
	;ldi temp2,0xFF
	;ldi temp6,8

	; negativ ?
	tst temp2
	brmi DS_TEMPERATUR_BERECHNEN_NEGATIV 
	rjmp DS_TEMPERATUR_BERECHNEN_POSITIV
;----------------------------------------------------------------------------------
DS_TEMPERATUR_BERECHNEN_POSITIV:
	; BIT 0 clear (0,5 GRD ignorieren)	
	andi temp1,0b11111110
	; mal 5 (4 mal addieren)			
	; ERGEBNIS: Bsp. 210 fr 21 GRD		
	mov temp,temp1

	add temp1,temp	; x2
	adc temp2,NULL
	add temp1,temp	; x3
	adc temp2,NULL
	add temp1,temp	; x4
	adc temp2,NULL
	add temp1,temp	; x5
	adc temp2,NULL
	; BERECHNEN			
	rcall DS_TEMPERATUR_BERECHNEN_B

	; addieren			
	add temp1,temp6	; 
	adc temp2,NULL	
	; -0,25 (-2)		
	subi temp1,LOW (2)
	sbci temp2,HIGH(2)
	ret
;----------------------------------------------------------------------------------
DS_TEMPERATUR_BERECHNEN_NEGATIV:
	; invertieren	
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
	; BIT 0 clear (0,5 GRD ignorieren)	
	andi temp1,0b11111110
	; mal 5 (4 mal addieren)			
	; ERGEBNIS: Bsp. 210 fr 21 GRD		
	mov temp,temp1

	add temp1,temp	; x2
	adc temp2,NULL
	add temp1,temp	; x3
	adc temp2,NULL
	add temp1,temp	; x4
	adc temp2,NULL
	add temp1,temp	; x5
	adc temp2,NULL



	; BERECHNEN			
	rcall DS_TEMPERATUR_BERECHNEN_B
	; 9-temp6			
	ldi temp,9
	sub temp,temp6
	mov temp6,temp

	cpi temp6,0
	breq DS_TEMPERATUR_BERECHNEN_NEGATIV_W0
	cpi temp6,1
	breq DS_TEMPERATUR_BERECHNEN_NEGATIV_W1
	cpi temp6,2
	breq DS_TEMPERATUR_BERECHNEN_NEGATIV_W2
	cpi temp6,3
	breq DS_TEMPERATUR_BERECHNEN_NEGATIV_W3
	cpi temp6,4
	breq DS_TEMPERATUR_BERECHNEN_NEGATIV_W4
	cpi temp6,5
	breq DS_TEMPERATUR_BERECHNEN_NEGATIV_W5
	cpi temp6,6
	breq DS_TEMPERATUR_BERECHNEN_NEGATIV_W6
	cpi temp6,7
	breq DS_TEMPERATUR_BERECHNEN_NEGATIV_W7
	cpi temp6,8
	breq DS_TEMPERATUR_BERECHNEN_NEGATIV_W8
	cpi temp6,9
	breq DS_TEMPERATUR_BERECHNEN_NEGATIV_W9


DS_TEMPERATUR_BERECHNEN_NEGATIV_W0:
	subi temp1,(-3)	;+3
	rjmp DS_TEMPERATUR_BERECHNEN_NEGATIV_FERTIG
DS_TEMPERATUR_BERECHNEN_NEGATIV_W1:
	subi temp1,(-4)	;+4
	rjmp DS_TEMPERATUR_BERECHNEN_NEGATIV_FERTIG
DS_TEMPERATUR_BERECHNEN_NEGATIV_W2:
	subi temp1,(-5)	;+5
	rjmp DS_TEMPERATUR_BERECHNEN_NEGATIV_FERTIG
DS_TEMPERATUR_BERECHNEN_NEGATIV_W3:
	subi temp1,(-6)	;+6
	rjmp DS_TEMPERATUR_BERECHNEN_NEGATIV_FERTIG
DS_TEMPERATUR_BERECHNEN_NEGATIV_W4:
	subi temp1,(-7)	;+7
	rjmp DS_TEMPERATUR_BERECHNEN_NEGATIV_FERTIG
DS_TEMPERATUR_BERECHNEN_NEGATIV_W5:
	subi temp1,(2)	;-2
	rjmp DS_TEMPERATUR_BERECHNEN_NEGATIV_FERTIG
DS_TEMPERATUR_BERECHNEN_NEGATIV_W6:
	subi temp1,(1)	;-1
	rjmp DS_TEMPERATUR_BERECHNEN_NEGATIV_FERTIG
DS_TEMPERATUR_BERECHNEN_NEGATIV_W7:
	subi temp1,(0)	;0
	rjmp DS_TEMPERATUR_BERECHNEN_NEGATIV_FERTIG
DS_TEMPERATUR_BERECHNEN_NEGATIV_W8:
	subi temp1,(-1)	;+1
	rjmp DS_TEMPERATUR_BERECHNEN_NEGATIV_FERTIG
DS_TEMPERATUR_BERECHNEN_NEGATIV_W9:
	subi temp1,(-2)	;+2
	rjmp DS_TEMPERATUR_BERECHNEN_NEGATIV_FERTIG





DS_TEMPERATUR_BERECHNEN_NEGATIV_FERTIG:
	; invertieren	
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
	ret
;----------------------------------------------------------------------------------
DS_TEMPERATUR_BERECHNEN_B:
	; COUNT_REMAIN (temp6) mal 10 		
	mov temp,temp6
	LSL temp6		; x2 (x2) 
	LSL	temp6		; x2 (x4) 
	LSL temp6		; x2 (x8) 
	add temp6,temp	; +  (x9) 
	add temp6,temp	; +	 (x10)
	; 160- temp6	
	ldi temp,160
	sub temp, temp6
	mov temp6,temp
	; temp6 aufrunden (halben DIVISOR addieren)
	subi temp6,(-8)
	; temp6 durch 16		
	LSR temp6		; :2 (:2)
	LSR temp6		; :2 (:4)
	LSR temp6		; :2 (:8)
	LSR temp6		; :2 (:16)

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
