;												
; DS1820 DS18s20 								
; ATmega8 / 1MHz								
; Bernhard.Erfurt@gmx.de						
; 11/2011										
;												
; LCD 16x2										
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> LCD									
; PB1 ==> LCD									
; PB2 ==> LCD									
; PB3 ==> LCD									
; PB4 ==> LCD									
; PB5 ==> LCD									
; PB6 ==> Quarz									
; PB7 ==> Quarz									
;												
; PC0 ==> 1-WIRE-DATENBUS						
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> 										
; PC4 ==> 										
; PC5 ==> 										
;												
; PD0 ==> LED-A		(SAMPLES RESET PRESENCE)	
; PD1 ==> LED-B		(MASTER write)				
; PD2 ==> LED-C		(SAMPLES MASTER read)		
; PD3 ==> LED-D									
; PD4 ==> LED-E									
; PD5 ==> LED GRN	(RESET PRESENCE OK)			
; PD6 ==> LED GELB	(MESSUNG aktiv)				
; PD7 ==> LED ROT	(CRC ERROR)					
;												


; ATmega8 										
.include "m8def.inc"
; KONSTANTEN									
.equ TAKT					= 1000000			; 1 MHz	
; 1-WIRE-DATENBUS								
.equ ONE_WIRE_DDR			= DDRC
.equ ONE_WIRE_PORT			= PORTC
.equ ONE_WIRE_PIN			= PINC
.equ ONE_WIRE_PORTBIT		= 0

; LEDS 											
.equ LED_D_TRIGGER_SAMPLES_PRESENCE	= 0			; TRIGGER fr PRESENCE			
.equ LED_D_TRIGGER_MASTER_TX		= 1			; TRIGGER fr MASTER WRITE		
.equ LED_D_TRIGGER_MASTER_RX		= 2			; TRIGGER fr MASTER READ		
.equ LED_D_TRIGGER_SAMPLES_RX		= 3
.equ LED_D_RESERVE			= 4
.equ LED_D_GRUEN			= 5
.equ LED_D_GELB				= 6
.equ LED_D_ROT				= 7
; LCD											
.equ LCD_PORT				= PORTB
.equ LCD_D0					= 0
.equ LCD_D1					= 1
.equ LCD_D2					= 2
.equ LCD_D3					= 3
; LCD RS (Befehl/DATEN)							
.equ LCD_RS_PORT			= PORTB
.equ LCD_RS					= 4
; LCD_ENABLE									
.equ LCD_E_PORT				= PORTB
.equ LCD_E					= 5


; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					= 0x0060			; 0x0060 START Adresse 		

.equ adr_TESTZAHL				= 0x0060+1

.equ adr_ANZAHL_SLAVES			= 0x0060+10			; ANZAHL gefundener SLAVES			

.equ adr_TEMPERATUR_L			= 0x0060+40			; ZWISCHENERGEBNIS Temperaturwerte	(0,1 GRD)	
.equ adr_TEMPERATUR_H			= 0x0060+41
.equ adr_TEMPERATUR9_L			= 0x0060+42			; ZWISCHENERGEBNIS Temperaturwerte (nur 9 BIT)	
.equ adr_TEMPERATUR9_H			= 0x0060+43


.equ adr_TEMPERATUR_0_L			= 0x0060+50			; Temperaturwerte SLAVE 0 (0,1 GRD)		
.equ adr_TEMPERATUR_0_H			= 0x0060+51
.equ adr_TEMPERATUR_1_L			= 0x0060+52			; Temperaturwerte SLAVE 1 (0,1 GRD)		
.equ adr_TEMPERATUR_1_H			= 0x0060+53
.equ adr_TEMPERATUR_2_L			= 0x0060+54			; Temperaturwerte SLAVE 2 (0,1 GRD)		
.equ adr_TEMPERATUR_2_H			= 0x0060+55
.equ adr_TEMPERATUR_3_L			= 0x0060+56			; Temperaturwerte SLAVE 3 (0,1 GRD)		
.equ adr_TEMPERATUR_3_H			= 0x0060+57
.equ adr_TEMPERATUR_4_L			= 0x0060+58			; Temperaturwerte SLAVE 4 (0,1 GRD)		
.equ adr_TEMPERATUR_4_H			= 0x0060+59
.equ adr_TEMPERATUR_5_L			= 0x0060+60			; Temperaturwerte SLAVE 5 (0,1 GRD)		
.equ adr_TEMPERATUR_5_H			= 0x0060+61
.equ adr_TEMPERATUR_6_L			= 0x0060+62			; Temperaturwerte SLAVE 6(0,1 GRD)		
.equ adr_TEMPERATUR_6_H			= 0x0060+63
.equ adr_TEMPERATUR_7_L			= 0x0060+64			; Temperaturwerte SLAVE 7 (0,1 GRD)		
.equ adr_TEMPERATUR_7_H			= 0x0060+65
.equ adr_TEMPERATUR_8_L			= 0x0060+66			; Temperaturwerte SLAVE 8 (0,1 GRD)		
.equ adr_TEMPERATUR_8_H			= 0x0060+67
.equ adr_TEMPERATUR_9_L			= 0x0060+68			; Temperaturwerte SLAVE 9 (0,1 GRD)		
.equ adr_TEMPERATUR_9_H			= 0x0060+69

.equ adr_TEMPERATUR9_0_L		= 0x0060+70			; Temperaturwerte SLAVE 0 (nur 9 BIT)	
.equ adr_TEMPERATUR9_0_H		= 0x0060+71
.equ adr_TEMPERATUR9_1_L		= 0x0060+72			; Temperaturwerte SLAVE 1 (nur 9 BIT)	
.equ adr_TEMPERATUR9_1_H		= 0x0060+73
.equ adr_TEMPERATUR9_2_L		= 0x0060+74			; Temperaturwerte SLAVE 2 (nur 9 BIT)	
.equ adr_TEMPERATUR9_2_H		= 0x0060+75
.equ adr_TEMPERATUR9_3_L		= 0x0060+76			; Temperaturwerte SLAVE 3 (nur 9 BIT)	
.equ adr_TEMPERATUR9_3_H		= 0x0060+77
.equ adr_TEMPERATUR9_4_L		= 0x0060+78			; Temperaturwerte SLAVE 4 (nur 9 BIT)	
.equ adr_TEMPERATUR9_4_H		= 0x0060+79
.equ adr_TEMPERATUR9_5_L		= 0x0060+80			; Temperaturwerte SLAVE 5 (nur 9 BIT)	
.equ adr_TEMPERATUR9_5_H		= 0x0060+81
.equ adr_TEMPERATUR9_6_L		= 0x0060+82			; Temperaturwerte SLAVE 6 (nur 9 BIT)	
.equ adr_TEMPERATUR9_6_H		= 0x0060+83
.equ adr_TEMPERATUR9_7_L		= 0x0060+84			; Temperaturwerte SLAVE 7 (nur 9 BIT)	
.equ adr_TEMPERATUR9_7_H		= 0x0060+85
.equ adr_TEMPERATUR9_8_L		= 0x0060+86			; Temperaturwerte SLAVE 8 (nur 9 BIT)	
.equ adr_TEMPERATUR9_8_H		= 0x0060+87
.equ adr_TEMPERATUR9_9_L		= 0x0060+88			; Temperaturwerte SLAVE 8 (nur 9 BIT)	
.equ adr_TEMPERATUR9_9_H		= 0x0060+89



.equ adr_DS_SCRATCHPAD_BEREICH	= 0x0060+100	; SCRATCHPAD+CRC(9BYTE)				
.equ adr_ROM_CRC_BEREICH		= 0x0060+110	; ROM + CRC		(8 BYTE)			
.equ adr_ROM_SEARCH_KNOTEN		= 0x0060+200	; fr ROM Suche (64Byte)			
.equ adr_ROM_SLAVE_LISTE		= 0x0060+600	; ROM			(8 BYTE)			

.equ adr_SRAM_CHECK				= 0x0060+900	; SRAM CHECK 						

; REGISTER										

.def NULL 	= R1
.def EINS 	= R2
.def VOLL	= R3

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25





.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   	  	; Timer1 Overflow Handler       
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Bei unkorrekten Interrupt aufrufen erfolgt ein RESET ber WDR	
INTERRUPT_ERROR:
	wdr	
	cbi PORTD,LED_D_ROT		; LED ROT			
INTERRUPT_ERROR_SCHLEIFE:
	rjmp INTERRUPT_ERROR_SCHLEIFE

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	clr temp
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND); Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND)	; Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	breq SRAM_CLEAR_w	; gleich  => SPRUNG	


; PORT B initialisieren								
	ldi temp, 0b00111111	; DISPLAY	
	out DDRB, temp
; PORT B setzen										
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000000	; DS1820
	out DDRC, temp
; PORT C setzen										
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b11111111	; LED-ROT/LED-GELB/LED-GRN/LED_E/LED-D/LED-C/LED-B/LED-A
	out DDRD, temp
; PORT D setzen										
	ldi temp, 0b00000000	; alle LEDs an			
	out PORTD, temp				
; WDR-INITIALISIERUNG								
	rcall WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
	sbi PORTD,LED_D_GRUEN	; GRN	
	sbi PORTD,LED_D_GELB	; GELB 	
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	sbi PORTD,LED_D_GRUEN	; GRN	
	sbi PORTD,LED_D_GELB	; GELB 	
; Interrupts freigeben								
	sei
; LCD_INITIALISIERUNG								
	rcall LCD_INITIALISIERUNG
; ANZEIGE_BEGRUESSUNG								
	rcall ANZEIGE_BEGRUESSUNG
	rcall wait_1s
; LEDs alle aus										
;	sbi PORTD,LED_D_A		; LED-A		
;	sbi PORTD,LED_D_B		; LED-B		
;	sbi PORTD,LED_D_C		; LED-C		
;	sbi PORTD,LED_D_D		; LED-D		
;	sbi PORTD,LED_D_E		; LED-E		
	sbi PORTD,LED_D_GRUEN	; GRN	
	sbi PORTD,LED_D_GELB	; GELB 	
	sbi PORTD,LED_D_ROT		; ROT	

	; Vorsicht bei diesen Funktionen,			
	; aales SLAVES im BUS werden beschrieben !	
	;rcall DS_SCRATCHPAD_WRITE
	;rcall DS_SCRATCHPAD_COPPY
	;rcall DS_SCRATCHPAD_RECALLEEPROM

; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	;rcall BEISPIEL_1	; nur ein unbekannter Slave vorhanden Temperatur und ROM auslesen anzeigen							
	;rcall BEISPIEL_2	; mehrere bekannte Slaves (s.TABELLE) sind vorhanden, Temperaturen auslesen und anzeigen			
	rcall BEISPIEL_3	; mehrere unbekannte Slaves sind vorhanden, ROM Suche und auslesen und in LISTE ablegen				
	rcall PROGRAMM_CHECK
	rcall wait_100ms
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
; nur ein Slave vorhanden Temperatur und ROM anzeigen							
BEISPIEL_1:
	rcall DS_MESSEN_ALLE
	rcall DS_ROM_READ_1_SLAVE
	rcall DS_SCRATCHPAD_READ_1_SLAVE
	rcall ANZEIGE_ROM_NUR_1_SLAVE
	rcall wait_1s
	rcall ANZEIGE_TEMPERATUR_SCRATCHPAD_NUR_1_SLAVE
	rcall wait_1s
	rcall wait_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; mehrere bekannte Slaves sind vorhanden, Temperaturen auslesen und anzeigen	
BEISPIEL_2:
	rcall DS_MESSEN_ALLE
	rcall DS_SCRATCHPAD_READ_DIREKT_SLAVE_00
	rcall DS_SCRATCHPAD_READ_DIREKT_SLAVE_01
	rcall DS_SCRATCHPAD_READ_DIREKT_SLAVE_02	
	rcall DS_SCRATCHPAD_READ_DIREKT_SLAVE_03
	rcall DS_SCRATCHPAD_READ_DIREKT_SLAVE_04
	rcall DS_SCRATCHPAD_READ_DIREKT_SLAVE_05
	rcall DS_SCRATCHPAD_READ_DIREKT_SLAVE_06
	rcall DS_SCRATCHPAD_READ_DIREKT_SLAVE_07
	rcall DS_SCRATCHPAD_READ_DIREKT_SLAVE_08
	rcall DS_SCRATCHPAD_READ_DIREKT_SLAVE_09
	rcall ANZEIGE_TEMPERATUR_6_SLAVES
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; mehrere unbekannte Slaves sind vorhanden										
BEISPIEL_3:

	rcall ROM_SEARCH
	;rcall ANZEIGE_ROM_SEARCH_0	; Anzahl SLAVES und 1xROM						
	;rcall ANZEIGE_ROM_SEARCH_1	; 2xROM											
	;rcall ANZEIGE_ROM_SEARCH_2 ; Anzahl SLAVES und nur Prfsumme max 10xROM	
	rcall ANZEIGE_ROM_SEARCH_3 ; ROM aller SLAVES nacheinander anzeigen			

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; DATEIEN																		
.include "DS_DS18s20.asm"
.include "DS_1-WIRE.asm"
.include "DS_1-WIRE_SEARCH.asm"
.include "DS_LCD.asm"		; LCD 16x2		
.include "DS_SONSTIGES.asm" ; WDR			
.include "DS_WAIT.asm"		; Warteschleifen

; ##############################################################################
; ##############################################################################
; ##############################################################################
; TEXTE																			
TEXT_BEGRUESSUNG_1:
.db "DS1820 DS18s20",0

TEXT_BEGRUESSUNG_2:
.db "02.11.2011  - V4",0

TEXT_ROM:
.db "ROM:",0

TEXT_SLAVES:
.db "SLAVES:",0

TEXT_TEMPERATUR:
.db "TEMPERATUR:",0

TEXT_SLAVE0:
.db "SL0:",0

TEXT_SLAVE1:
.db "SL1:",0
; ##############################################################################
; ##############################################################################
; ##############################################################################
SENSOR_ROM_00:
.db 0x10,0x09,0x64,0x53,0x02,0x08,0x00,0x0A
SENSOR_ROM_01:
.db 0x10,0x1A,0x66,0x53,0x02,0x08,0x00,0x8B
SENSOR_ROM_02:
.db 0x10,0x9B,0x79,0x53,0x02,0x08,0x00,0x45
SENSOR_ROM_03:
.db 0x10,0xED,0x5F,0x53,0x02,0x08,0x00,0x0B
SENSOR_ROM_04:
.db 0x10,0x10,0xAE,0x53,0x02,0x08,0x00,0x58
SENSOR_ROM_05:
.db 0x10,0xB6,0xA2,0x53,0x02,0x08,0x00,0x97
SENSOR_ROM_06:
.db 0x10,0x9C,0x66,0x53,0x02,0x08,0x00,0xD3
SENSOR_ROM_07:
.db 0x10,0x3E,0x94,0x53,0x02,0x08,0x00,0xC4
SENSOR_ROM_08:
.db 0x10,0x38,0x7D,0x53,0x02,0x08,0x00,0x5F
SENSOR_ROM_09:
.db 0x10,0xF7,0x80,0x53,0x02,0x08,0x00,0xAE




















